{$A+,B+,F+,G+,I-,O-,V-,D-,L-,Q-,R-,S-,E-,N+
original by: eric mcdaniel in summer '97  email: stdemm01@shsu.edu
language: tp7.0 pascal (running under real and protected mode !)
improved by MrPix@geocities.com

description:
  voxel program similar to vp3(a voxel plasma) but
  more realistic.  i spent many hours programing this
  after i programmed vp3.  i cant draw realisticly for
  anything... so i used a picture i got off the
  internet.  while the ground.bmp isnt even close to
  being in its orginal form, it still looks about
  the same (originally it was a pcx picture of
  512x512x256, now its a bmp picture of 256x256x256).
  the reason for changing this picture is that bmps are
  the only format i know how to read and i needed it to
  be smaller because of pascals limited amount of memory.
  i made height.bmp from scratch (with the help of a
  program i made and paint shop pro).
files:
  vox.pas
  ground*.bmp
  height*.bmp
}

uses  crt,dos,kbrd;

const pagesize=320*200;
      maxDist=1024;
      dist:word=100; {setting it higher will let you see further but}
                     {it will also make frames per second (fps) less}
      cnst=20;       {added to forward/backward time}
      tm=100;        {random forward/backward time}
      tcnst=1;       {added to left/right time}
      ttm=10;        {random left/right time}
      maxX = 319;

type  halfmap=array[0..$7fff] of byte;      {1/2 of 65536 because pascal-}
      fullmap=array[0..1] of ^halfmap;      {-can only handle up to 65535!!!}
      vscr=array[0..pageSize-1] of byte;    {virtual screen}

var   kbd:kbrdobj;                          {the keyboard handler}
      hmap:fullmap;                         {height map}
      tmap:fullmap;                         {texture map}
      buffer:^vscr;                         {the buffer}
      vbuff:word;                           {buffers address}
      cost,sint:array[0..2048] of integer;  {cosin and sin tables}
      dct:array[1..maxdist] of integer;     {distance compensation table}
      x,y,angle,xx,yy:word;                 {camera info}
      h,height:longint;                     {camera info}
      xd,yd,ad, step: longint;
      pal,map,cd,md,op,om:boolean;            {comp/pal control}
      s1:string;                            {the subdirs}
      a12,b12,c12,d12:boolean;              {used for comp control}
      starttime,endtime,fps:longint;        {used for fps}
      timePtr: ^longint;                    {pointer to time counter}

{this copies the entire screen at source to dest}
procedure Flip(source,dest:word); assembler;
asm
  push ds
  mov ax,[dest]
  mov es,ax
  mov ax,[source]
  mov ds,ax
  xor si,si
  xor di,di
  mov cx,32000
  rep movsw
  pop ds
end;

{this sets the mode}
procedure Mode(m:word);assembler;
asm
  mov ax,m
  int 10h
end;

{this sets a dac register to a specific rgb value}
procedure setdac(num,r,g,b:byte);
begin
  port[$3c8]:=num;
  port[$3c9]:=r;
  port[$3c9]:=g;
  port[$3c9]:=b;
end;

{draws a vertical line down the screen}
procedure DrawVert(x,y1,y2:integer;c:byte);assembler;
asm
  mov ax,y1
  shl ax,6
  mov bx,ax
  shl ax,2
  add bx,ax
  add bx,x      {bx:=y1*320+x}

  mov dx,y2
  inc dx
  sub dx,y1     {dx:=y2+1-y1}

  mov ax,vbuff  {es:=seg(buffer^)}
  mov es,ax

  mov al,c
  @loop:
  mov byte ptr[es:bx],al {actually draws a pixel at mem[vbuff:bx]}
  dec dx        {dx-=1}
  cmp dx,0
  je @fin       {if dx=0 then jump @fin}
  add bx,320    {bx+=320}
  jmp @loop     {jump @loop}
  @fin:
end;

{casts a verticle ray and renders result}
procedure ray(a,x,y,sx:word);
var dx,dy,p,o,d, my:integer;
    h,y2:longint;
begin
  dx:=cost[a];
  dy:=sint[a];
  my:=200;
  d:=0;
  repeat
    inc(x,dx);
    inc(y,dy);
    inc(d);                       {new distance}
    p:=y shr 15;                  {calculate offset into map}
    o:=(y and $7f00)+hi(x);
    h:=longint(hmap[p]^[o])-height;
    y2:=dct[d]-(h shl 5)div d;    {calculate height}
    if y2<0 then
    y2:=0;
    if (y2<my) then
    begin
      DrawVert(sx,y2,my-1,tmap[p]^[o]);  {voxel}
      my:=y2;
    end;
  until d>=dist;
end;

{mem[where:a+b*320]:=c}
procedure plot(xp,yp:word;c:byte);assembler;
asm
  mov ax,vBuff
  mov es,ax
  mov ax,yp
  shl ax,6
  mov bx,ax
  shl ax,2
  add ax,bx
  add ax,xp
  mov di,ax
  mov al,c
  mov [es:di],al
end;

{draws palette}
procedure drawPal;
var a:word;
begin
  for a := 0 to 255
  do DrawVert (a,1,10, a);
end;

{draws map in corner}
procedure drawMap;
const xknst=255;
      yknst=1;
var a,b,c,d,oa:word;
begin
  d:=0;
  oa:=0;
  for a := 32 to 63 do
  for b := 0 to 63 do
  begin
    if oa<>a then
    inc(d,768);
    plot(xknst+b,yknst+a,tmap[0]^[d]);
    inc(d,4);
    oa:=a;
  end;
  d:=0;
  oa:=0;
  for a := 0 to 31 do
  for b := 0 to 63 do
  begin
    if oa<>a then
    inc(d,768);
    plot(xknst+b,yknst+a,tmap[1]^[d]);
    inc(d,4);
    oa:=a;
  end;
  c:=(y and $7f00)+hi(x);
  d:=(c mod 256) div 4;
  c:=(c div 256) div 4;
  if y shr 15 = 0 then
  c:=c+31;
  plot(xknst+d,yknst+c,0);
  plot(xknst+(d+cost[(angle+768)and 2047] div 128),
       yknst+(c+sint[(angle+768)and 2047] div 128),0);
  plot(xknst+(d+cost[(angle+1280)and 2047] div 128),
       yknst+(c+sint[(angle+1280)and 2047] div 128),0);
  {last 3 lines are you}
end;

{calculates whole screen view}
procedure DrawView;
var a,i:integer;
    dd:integer;
begin
  for i:=0 to maxX                {fill every column}
  do begin
    a:=(angle+i+1888) and 2047;   {calculate ray angle with view angle}
    ray(a,x,y,i);                 {cast the ray}
  end;
end;

const maxMap = 2;
      mapList: array [0..2*maxMap+1] of string[12]
      = ('height1.bmp', 'ground1.bmp'
        ,'height2.bmp', 'ground2.bmp'
        ,'height3.bmp', 'ground3.bmp');
      actMap: word = 0;

{reads bmps into maps}
procedure OpenFile (var f: file; name: string);
var  ioError: integer;
begin
  assign (f,name);
  reset(f,1);
  ioError := ioResult;
  if ioError <> 0
  then begin
    Mode(3);                      {switch back to text}
    writeln ('file error ',ioError,' at open ',name);
    halt (ioError);
  end;
end;

{read bmps into maps}
procedure LoadMaps (mno: word);
var   num,r,g,b:byte;
      f:file;
begin
  actMap := mno mod (maxMap+1);
  OpenFile (f,mapList[actMap*2+1]);
  seek(f,54);                     {the palette starts at byte 54}
  for num:=0 to 255 do
  begin
    blockread(f,tmap[0]^,4);
    b:=tmap[0]^[0] shr 2;
    g:=tmap[0]^[1] shr 2;
    r:=tmap[0]^[2] shr 2;
    setdac(num,r,g,b);
  end;
  blockread(f,tmap[0]^,32768);    {load texture map}
  blockread(f,tmap[1]^,32768);
  close(f);

  OpenFile (f,mapList[actMap*2]);
  seek(f,1078);                   {skip the palette for this one}
  blockread(f,hmap[0]^,32768);
  blockread(f,hmap[1]^,32768);
  close(f);
end;

{get memory and read maps}
procedure InitMap;
begin
  new(tmap[0]);                   {assign 64k for a 256x256 texture map}
  new(tmap[1]);
  new(hmap[0]);                   {assign 64k for a 256x256 height map}
  new(hmap[1]);
  LoadMaps (0);
end;

{calculates lookup tables}
procedure InitTables;
var a:word;
begin
  for a:=0 to 2047 do
  begin
    cost[a]:=trunc(cos(a*pi/1024)*256);   {precalculate cosin}
    sint[a]:=trunc(sin(a*pi/1024)*256);   {and sin}
  end;
  for a:=1 to maxdist                     {precalculate distance table}
  do dct[a]:=(4*maxdist) div a + 20;
end;

const noTurn = 16;

{change turn speed}
procedure Steer (add: integer);
begin
  if (ad + add) and $FFE0 = 0
  then ad := (ad + add);
  angle:=(angle+ad-noTurn) and 2047;
  xd := cost[angle];
  yd := sint[angle];
end;

procedure Reset;
begin
  ad     := 16;              {init turn speed}
  step   := 2;               {init speed}
  Steer(0);                  {init direction}
  h      := 28;              {init delta height}
  height := 20;              {init height}
  dist   := 100;
end;

function ModeMsg: string;
begin
  ModeMsg :=
  {$ifdef DPMI} 'DOS protected mode';
  {$else}       'DOS real mode';
  {$endif}
end;

{$ifopt D+}
  var tf:text;
{$endif}

var i,xs,ys: integer;

procedure Intro;
begin
  writeln ('VOX  9/99   running under ',ModeMsg
          ,memAvail:10,' bytes free'#13#10#13#10
          ,'    c   color palette'#13#10
          ,'    m   map on/off'#13#10
          ,'    l   load next map'#13#10
          ,'    r   reset values'#13#10
          ,'   +/-  deep'#13#10
          ,' arrows move/turn'#13#10
          ,'  page  up/down height'#13#10
          ,'   esc  exit'#13#10);

end;

begin
  Intro;
  InitTables;
  a12 :=false;
  b12 :=false;
  c12 :=false;
  d12 :=false;
  cd :=false;
  md :=false;
  map := true;
  pal := false;
  om := md;
  x := 0;                           {set up player}
  y := 0;
  angle := 600;
  fps := 0;
  Reset;
  New(buffer);
  vbuff:=seg(buffer^);
{$ifopt D+}
  assign (tf,'test.tmp');
  rewrite (tf);
{$endif}
  delay (2000);
  Mode($13);                      {switch to graph mode 13h}
  InitMap;
  kbd.Init;
  timePtr := ptr (seg0040,$006C);
  starttime:=timePtr^;
  repeat
    {move}
    xs:=xd*(step shr 1);
    ys:=yd*(step shr 1);
    x:=word(x+xs);
    y:=word(y+ys);
    {adjust camera height according to height map}
    height:=height+hmap[y shr 15]^[(y and $7f00)+hi(x)];

    xx := word(x+ xs);
    yy := word(y+ ys);
    height := height+hmap[yy shr 15]^[(yy and $7f00)+hi(xx)];

    xx := word(xx+xs);
    yy := word(yy+ys);
    height := height+hmap[yy shr 15]^[(yy and $7f00)+hi(xx)];

    height := height div 4 + h;

    fillchar(buffer^,pageSize,229);  {clear the buffer}
    DrawView;                     {draw a screen}
    DrawVert (319, longint(maxDist - dist)*200 div maxDist, 199, 255);

    if map then drawMap;
    if pal then drawPal;

    Flip(vBuff,segA000);          {flip buffer to screen}
    inc(fps);

{$ifopt D+}
{  for i := 1 to 255
  do if kbd.down (i) then writeln (tf,i);
}
{$endif}

    {check keyboard input}
    cd:=kbd.down(46);              {'c'}
    md:=kbd.down(50);              {'m'}
    if cd and not op then pal:=not(pal);
    if md and not om then map:=not(map);
    op:=cd;
    om:=md;
    if      kbd.down (78) then if dist < maxDist-2 then inc(dist,2) else {+}
    else if kbd.down (74) then if dist >  10 then dec(dist,2);  {-}
    if      kbd.down(200) then inc(step)  {forward}
    else if kbd.down(208) then dec(step); {backward}
    if      kbd.down(203) then Steer(-1)  {left}
    else if kbd.down(205) then Steer(+1)  {right}
    else if ad > noturn   then Steer(-1)
    else if ad < noTurn   then Steer(+1);
    if      kbd.down(201) then inc (h,8)  {page up}
    else if kbd.down(209) then dec (h,8); {page down}
    if      kbd.down(19)  then reset;
    if      kbd.down(38)
    or      kbd.down(57)  then LoadMaps(actMap+1);
  until kbd.down(1);
  endtime:=timePtr^;
  Mode(3);                        {switch back to text}
  kbd.done;
  Intro;
  writeln('fps: ',fps/((endtime-starttime)/18.2):3:5);
  delay (2000);
  freemem(buffer,pageSize);
  freemem(tmap[0],sizeof(tmap[0]));
  freemem(tmap[1],sizeof(tmap[1]));
  freemem(hmap[0],sizeof(hmap[0]));
  freemem(hmap[1],sizeof(hmap[1]));
{$ifopt D+}
  close (tf);
{$endif}
end.
